// $Id: RelationsPairHandler.cpp,v 1.5 2007/11/21 12:44:33 frankb Exp $
//====================================================================
//
//        Package    : System (The POOL project)
//
//  Description: Generate neccessary infrastructure for the
//               SEAL plugin manager modules
//
//        @author      M.Frank
//====================================================================
#include "Reflex/Reflex.h"
#include <iostream>
#include "StorageSvc/IIOHandler.h"
#include "Reflex/Type.h"

void load_PairHandler() {}

template <class T>
class poolIOHandler : public pool::IIOHandler {
protected:
  ROOT::Reflex::Type m_class;
public:
  poolIOHandler(const ROOT::Reflex::Type& cl) : m_class(cl) {
    //std::cout << "Created IOHandler of type:" << cl->fullName() << std::endl;
  }

  virtual ~poolIOHandler() {
  }

  /// Release call: destroy all internally allocated resources.
  virtual void release() {
    delete this;
  }

  /// Callback for reading the object
  /** @param obj  [IN]   Pointer to user object.
    */
  virtual void onReadUpdate(void* obj);

  /// Callback for writing the object
  /** @param obj  [IN]   Pointer to user object.
    */
  virtual void onWriteUpdate(void* obj);
};

template <>
void poolIOHandler<std::pair<int,float> >::onReadUpdate(void* obj) {
  static int count = 0;
  if ( ++count < 20 )  {
    std::pair<int,float>* p = (std::pair<int,float>*)obj;
    std::cout << p->first << p->second << std::endl;
  }
}

template <>
void poolIOHandler<std::pair<int,float> >::onWriteUpdate(void* obj) {
  static int count = 0;
  if ( ++count < 20 )  {
    std::pair<int,float>* p = (std::pair<int,float>*)obj;
    std::cout << p->first << p->second << std::endl;
  }
}

#if 0
#include "PluginManager/ModuleDef.h"
#include "StorageSvc/IIOHandlerFactory.h"

namespace Gaudi {
  DEFINE_SEAL_MODULE();
  typedef poolIOHandler<std::pair<int, float> > PairHandler;
  DEFINE_SEAL_PLUGIN( pool::IIOHandlerFactory, PairHandler, "IIOHandler<std__pair<int,float>>" );
}
#endif
