/* C++ header file: Objectivity/DB DDL version 6.1.0         */

#ifndef _OBJY_FILE_H
#define _OBJY_FILE_H

//
// abstract interface to a file loaded in a Objy db as Blob
//
//   V 1.0  30/11/99     VI
//
#include<iosfwd>
#include<string>
#include "ooRunObj.h"

using namespace std;

class ObjyFile : public ooRunObj {
public:
  /// usual default constructor
  ObjyFile(){}

  /// virtual destructor
  virtual ~ObjyFile(){}

  /// make a persistent clone
  //virtual ooHandle(ObjyFile) clone(const ooRef(ooContObj) & hint) const =0;

  /// read from real file
  virtual void read(const string & fname);
  /// write to real file
  virtual void write(const string & fname) const;

  /// read from istream
  virtual void read(istream & is)=0;
  /// write to ostream
  virtual void write(ostream & os) const=0;
protected:
  static unsigned int computeFileSize(const string & fname);
  static unsigned int computeStreamSize(istream & is);
};
#endif /* !defined(_OBJY_FILE_H) */
