/* C++ header file: Objectivity/DB DDL version 6.1.0         */

#ifndef _OBJY_MEMORY_FILE_H
#define _OBJY_MEMORY_FILE_H

//
// a file loaded in a Objy db as Blob which fits in memory 
//
//   V 1.0  30/11/99     VI
//

#include <vector>
#include "ObjyFile.h"
#include<string>

class ObjyMemoryFile : public ObjyFile {
public:

  /// usual default constructor
  ObjyMemoryFile(){}

  /// constructor from file to read
  explicit ObjyMemoryFile(const string & fname, unsigned int isize=0);

  /// constructor from  stream to read
  explicit ObjyMemoryFile(istream & is, unsigned int isize=0);

  /// virtual destructor
  virtual ~ObjyMemoryFile(){}

  /// make a persistent clone
#if 0
  virtual ooHandle(ObjyFile) clone(const ooRef(ooContObj) & hint) const {
    ooHandle(ObjyFile) me;
    me = new ObjyMemoryFile(*this);
    CMSPool::placeIt(me, hint, "ObjyMemoryFile");
    return me;
  }
#endif
  /// read from real file
  virtual void read(const string & fname) { ObjyFile::read(fname);}
  /// write to real file
  virtual void write(const string & fname) const {ObjyFile::write(fname);}

  /// read from istream
  virtual void read(istream & is);
  /// write to ostream
  virtual void write(ostream & os) const;


protected:

  typedef vector<unsigned char> Blob;
  typedef Blob::iterator BI;
  typedef Blob::const_iterator BCI;

  Blob blob;
};
#endif /* !defined(_OBJY_MEMORY_FILE_H) */
