/* C++ header file: Objectivity/DB DDL version 6.1.0         */

#ifndef PAIRS_H_
#define PAIRS_H_
#include <vector>
#include <list>
#include <string>
#include <utility>
#include "pool/Ref.h"

namespace Pairs {
  struct Complement  {
    int i, j, k;
    Complement() {}
    virtual ~Complement() {}
  };
  template <class T> struct Templated  {
    T m_obj;
    Templated() {}
    virtual ~Templated() {}
  };
  template <class T> struct PairAggregate  {
    std::pair<Complement, pool::Ref<Templated<T> > > m_pair;
    PairAggregate() {}
    virtual ~PairAggregate() {}
  };
}
#endif /* !defined(PAIRS_H_) */
