#ifndef OO_SCOPE_OBJ_H
#define OO_SCOPE_OBJ_H
#include "pool/Ref.h"
#include "ooObj.h"
#include <string>
#include <map>
#include <ostream>


class ooScopeObj : public ooObj {
template<class ooScopeObj> class pool::Ref;
friend std::ostream & operator<< (std::ostream &, const ooScopeObj &);
public:

  ooScopeObj(); 

  virtual ~ooScopeObj();

  std::map<std::string, pool::Ref<ooScopeObj> > & GetNamesInScope();
  
  std::multimap<std::string, pool::Ref<ooScopeObj> > & GetScopesContainingName();

private:
  std::map<std::string, pool::Ref<ooScopeObj> > namesInScope;
  
  std::multimap<std::string, pool::Ref<ooScopeObj> > scopesContainingName;
};

std::ostream & operator<<( std::ostream& o, const ooScopeObj& pref);
std::ostream & operator<<( std::ostream& o, const std::pair<std::string, pool::Ref<ooScopeObj> >& pref);

#endif
