#ifndef POOL_VIRTUALVECTOR_H
#define POOL_VIRTUALVECTOR_H
#include <vector>
#include <algorithm>
#include "TObject.h"

template <class T> class my_allocator : public std::allocator<T>  {
  long   m_tmpBuff[32];   // Change artificially allocator size
public:
  my_allocator() {}
  template<class _Other> my_allocator(const my_allocator<_Other>&) {}
  ~my_allocator() {}
	template<class _Other> struct rebind		{
    // convert an allocator<_Ty> to an allocator <_Other>
	  typedef my_allocator<_Other> other;
  };
};

class ContainedBase  {
public:
  int data1, data2;
  Double32_t fdata32;
  ContainedBase() : data1(0), data2(0), fdata32(0) {}
  virtual ~ContainedBase() {}
};

class VirtualContained  : public virtual ContainedBase {
public:
  int data3;
  VirtualContained() : ContainedBase(), data3(0) {}
  virtual ~VirtualContained() {}
};

class NonVirtualContained  : public ContainedBase {
public:
  int data3;
  NonVirtualContained() : ContainedBase(), data3(0) {}
  virtual ~NonVirtualContained() {}
};

// just make sure the vector is not top level object in the branch
class VectorHolder  {
public:
  std::vector<ContainedBase*,my_allocator<ContainedBase*> > data;
  VectorHolder() {}
  virtual ~VectorHolder() {}
};

#endif // POOL_VIRTUALVECTOR_H
