# include "AttributeList/AttributeList.h"

# include <iostream>

using namespace pool;
using namespace std;

bool basic_attr_list()
{

  std::vector< std::pair<std::string, pool::typename_string_t> > columns1;
  columns1.push_back( std::make_pair("A","int"));
  columns1.push_back( std::make_pair("B","int"));
  columns1.push_back( std::make_pair("X", "string"));

  // different order
  std::vector< std::pair<std::string, pool::typename_string_t> > columns2;
  columns2.push_back( std::make_pair("B","int"));
  columns2.push_back( std::make_pair("A","int"));
  columns2.push_back( std::make_pair("X", "string"));

  pool::AttributeListSpecification spec1;

  for(unsigned int i=0; i<columns1.size(); ++i)
    spec1.push_back( columns1[i].first, columns1[i].second );

  pool::AttributeListSpecification spec2;

  for(unsigned int i=0; i<columns2.size(); ++i)
    spec2.push_back( columns2[i].first, columns2[i].second );


  pool::AttributeList alist1(spec1), alist2(spec2);

  cerr << endl;
  spec1.print(cerr); cerr << " -- ";  alist1.print(cerr); cerr << endl;
  spec2.print(cerr); cerr << " -- ";  alist2.print(cerr); cerr << endl;

  // lists with default values are equal
  assert(alist1 == alist2);

  // equal lists
  alist1["A"].setValue(10);
  alist1["B"].setValue(20);
  alist1["X"].setValue(std::string("xxx"));

  alist2["A"].setValue(10);
  alist2["X"].setValue(std::string("xxx"));
  alist2["B"].setValue(20);

  alist1.print(cerr); cerr << endl;
  alist2.print(cerr); cerr << endl;

  assert(alist1 == alist2);

  // nonequal lists
  alist1["A"].setValue(11);

  alist1.print(cerr); cerr << endl;
  alist2.print(cerr); cerr << endl;

  assert(alist1 != alist2);

  //individual attributes

  alist1["A"].setValue(10);
  alist1["B"].setValue(10);
  alist2["A"].setValue(10);

  assert(alist1["A"]==alist1["A"]);
  assert(alist1["A"]==alist2["A"]);
  assert(alist1["A"]==alist1["B"]); // yes, name ignored...

  return true;
}


