# include "AttributeList/AttributeListSpecification.h"

# include <assert.h>
#include <iostream>

using namespace pool;

bool spec_append_merge()
{
  pool::AttributeListSpecification abx;
  abx.push_back("A","int");
  abx.push_back("B","int");
  abx.push_back("X", "string");

  pool::AttributeListSpecification bax;
  bax.push_back("B","int");
  bax.push_back("A","int");
  bax.push_back("X", "string");

  assert( abx.append_and_merge(bax).equals(abx) );
  assert( bax.append_and_merge(abx).equals(bax) );

  pool::AttributeListSpecification ba;
  ba.push_back("B","int");
  ba.push_back("A","int");

  assert( ba.append_and_merge(abx).equals(bax) );

  std::cerr << std::endl;
  ba.append_and_merge(abx).print(std::cerr);
  std::cerr << std::endl;

  pool::AttributeListSpecification ba_string;
  ba_string.push_back("B","string");
  ba_string.push_back("A","string");

  try
    {
      ba_string.append_and_merge(ba);
      assert(0); // should throw duplicate_attribute exception
    }
  catch(const pool::attribute_duplicate& /* x */)
    {
      std::cerr << "attribute_duplicate - OK" << std::endl;
    }
  return 1;
}

