#ifndef POOL_DATASVCEXCEPTION_H
#define POOL_DATASVCEXCEPTION_H 

#include "POOLCore/Exception.h"
  
namespace pool    {

  /** @class DataSvcException DataSvcException.h pool/DataSvcException.h

      Define generic Exception for DataSvc misbehavior

      @author Giacomo Govi 
  */
  class DataSvcException : public pool::Exception {
    
    public:
    /** Standard Constructor
        @param m : Message error message
    */
    DataSvcException(const std::string& m) 
    : pool::Exception(m,"","DataSvc")     {
    }

    /** Standard Constructor
        @param m : Message error message
        @param t : Tag "name tag", or exeption type
    */
    DataSvcException(const std::string& m, const std::string& t) 
    : pool::Exception(m,t,"DataSvc")     {
    }
  
    /// destructor (perform the deletion of "previous" field!) 
    virtual ~DataSvcException() throw() {
    } 
  
    /// No assignment operator
    private:
    DataSvcException& operator=(const DataSvcException&);

  };  

}

#endif  // POOL_REFEXCEPTION_H
