// $Header: /cvs/PF/pool/DataSvc/DataSvc/IDataSvc.h,v 1.23 2008/03/06 17:58:57 govi Exp $
#ifndef POOL_IDATASVC_H
#define POOL_IDATASVC_H

namespace pool    {

  class IDataTransform;
  class ISession;
  class ITransaction;
  class IFileCatalog;
  class IConfiguration;
  class ICacheSvc;
  class DataSvcContext;

  /** @class IDataSvc IDataSvc.h DataSvc.h
      Abstract interface for the access to the  
      pool persistency services.

      @date 15/07/2002
  */
  class IDataSvc  {

    public:
    /// Constructor
    explicit IDataSvc( const DataSvcContext& ) {}

    /// Destructor
    virtual ~IDataSvc(){};

    /// Returns a reference to the IDataTransform object.
    virtual IDataTransform& dataTransform() = 0;

    /// Return a referenc to the IFileCatalog instance in use.
    virtual IFileCatalog& fileCatalog() = 0;

    /// Returns the underlying global session
    virtual ISession& session() = 0;

    /// Returns the current transaction
    virtual ITransaction& transaction() = 0;

    // Clear the cache content 
    virtual void clearCache() = 0;

    // delete the objects from all the cache entries
    virtual void resetCache() = 0;

    // Returns a reference to the ICacheSvc object.
    virtual ICacheSvc& cacheSvc()=0;

    // Access to the global POOL configuration
    virtual IConfiguration& configuration()=0;
    
  protected:

    IDataSvc() {}
    IDataSvc( const IDataSvc& );
    IDataSvc& operator=( const IDataSvc& );



  };   // class IDataSvc
}      // namespace pool

#endif  // POOL_IDATASVC_H












