#ifndef INCLUDE_DATASVC_CACHETRANSACTIONOBSERVER_H
#define INCLUDE_DATASVC_CACHETRANSACTIONOBSERVER_H

#include "PersistencySvc/ITransactionObserver.h"

namespace pool {

  class CacheSvc;

  /** @class CacheTransactionObserver CacheTransactionObserver.h DataSvc/CacheTransactionObserver.h
   *
   *  Implementation of ITransactionObserver interface class for the DataSvc caching.
   */

  class CacheTransactionObserver : public ITransactionObserver {
  public:
    /// constructor
    CacheTransactionObserver(CacheSvc& aCacheSvc);

    virtual ~CacheTransactionObserver(){};

    /// Responds to a start of a read transaction
    bool respondToStartRead(){ return true;}

    /// Responds to a start of an update transaction
    bool respondToStartUpdate(){ 
      return true;
    }

    /// Responds to a committing of a transaction
    bool respondToCommit();

    /// Responds to an aborting of a transaction
    bool respondToRollBack();

    /// Responds to the reverting of a transaction into update mode
    bool respondToUpdate(){ return true;}
  private:
    CacheTransactionObserver();  

    CacheSvc& m_cacheSvc;

  };
}

#endif
