#ifndef POOL_REFCOUNTER_H
#define POOL_REFCOUNTER_H 

namespace pool    {
 
  class RefCounter {

    private:

      // reference counter
      unsigned int refcounter;

    public:

    RefCounter(): refcounter(0) {}
   
    virtual ~RefCounter(){}

    // adds a count on the reference counter
    unsigned int incrementCount(){
      refcounter++;
      return refcounter;
    }

    // remove a count from the reference counter
    unsigned int decrementCount(){
      if(refcounter) refcounter--;
      return refcounter;
    }

    // reset the reference counter
    void resetCount(){
      refcounter = 0;
    }

    // returns the current reference counter
    unsigned int refCount() const {
      return refcounter;
    }


  };
}

#endif
