#ifndef LFCCATALOG_LFCMETACATALOG_H
#define LFCCATALOG_LFCMETACATALOG_H

#ifndef POOL_FCMETAIMPL_H
#include "FileCatalog/FCMetaImpl.h"
#endif
#include "FileCatalog/FCBuf.h"

#include <memory>

namespace pool {
  class FCImpl;
  class MetaDataEntry;
  /**
   * @class LFCMetaCatalog LFCMetaCatalog.h
   *
   * Implementation of the FCMetaImpl interface for a LFC Catalog
   */
  
  class LFCMetaCatalog: public FCMetaImpl {
  public: 

    LFCMetaCatalog(FCImpl* fc);
    virtual ~LFCMetaCatalog();

    /// Methods from FCMetaImpl

    virtual void insertMetaData(MetaDataEntry& mentry) const;
    virtual void createMetaDataSpec( MetaDataEntry& schemadef) const;
    virtual void updateMetaDataSpec( MetaDataEntry& schemadef, const FileCatalog::MetaUpdateMode metamode=FileCatalog::NO_DELETE) const;
    virtual void getMetaDataSpec( MetaDataEntry& schemadef) const;
    virtual void dropMetaDataSpec() const;
    virtual void deleteMetaData(const FileCatalog::FileID& guid) const;

    //functions for bulk query

    virtual bool retrievePFN(const std::string& query, FCBuf<PFNEntry>& buf, const size_t& start );
    virtual bool retrieveLFN(const std::string& query, FCBuf<LFNEntry>& buf, const size_t& start );
    virtual bool retrieveMetaData(const std::string& query, FCBuf<MetaDataEntry>& buf, const size_t& start );
    virtual bool retrieveGuid(const std::string& query, FCBuf<FileCatalog::FileID>& buf, const size_t& start );
    
  private:

  };
}
#endif
