/*
 * Copyright (C) 2003-2004 by CERN
 */

/*
 * @(#)$RCSfile: gfal_api.h,v $ $Revision: 1.6 $ $Date: 2008/02/20 09:38:25 $ C
ERN Jean-Philippe Baud
 */

#ifndef _GFAL_API_H
#define _GFAL_API_H
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#include <string>

#ifndef GFAL_LONG64_FORMAT
#if defined(__ia64__) || defined(__x86_64)
#define GFAL_LONG64_FORMAT "%ld"
#elif defined(_WIN32)
#define GFAL_LONG64_FORMAT "%I64d"
#else
#define GFAL_LONG64_FORMAT "%lld"
#endif
#endif
#ifndef GFAL_LONG64
#if defined(__ia64__) || defined(__x86_64)
#define GFAL_LONG64 long
#elif defined(_WIN32)
#define GFAL_LONG64 __i64
#else
#define GFAL_LONG64 long long
#endif
#endif

char *getbestfile(char **, int size, char *, int);
int gfal_errmsg (char*, int, const char*);
int lfc_getfilesizeg(const char *, GFAL_LONG64 *, char *, int);
int lfc_create_alias (const char *, const char *, GFAL_LONG64, char *, int);
int lfc_deletepfn (const char *, const char *, char *, int);
int lfc_deletesurl (const char *, char *, int);
char *lfc_guidforpfn (const char *, char *, int);
char *lfc_guidfromlfn (const char *, char *, int);
char **lfc_lfnsforguid (const char *, char *, int);
int lfc_guid_exists (const char *, char *, int);
int lfc_mkdirp (const char*, mode_t, char *, int);
int lfc_register_alias (const char *, const char *, char *, int);
int lfc_register_pfn (const char *, const char *, char *, int);
int lfc_replica_exists (const char*, char*, int);
char *lfc_surlfromguid (const char *, char *, int);
char **lfc_surlsfromguid (const char *, char *, int);
int lfc_unregister_alias (const char *, const char *, char *, int);
int lfc_unregister_pfn (const char *, const char *, char *, int);

#endif
