/* 
 * Concrete implementation of the POOL to LFC MetaData Catalog interface
 * Author : David Smith
 */
#include "Reflex/PluginService.h"
#include "LFCCatalog/LFCMetaCatalog.h"
#include "LFCCatalog/LFCCatalog.h"

#include "FileCatalog/FCException.h"

#include "CoralBase/MessageStream.h"

namespace pool {

  PLUGINSVC_FACTORY_WITH_ID(LFCMetaCatalog, std::string("lfccatalog_meta"), FCMetaImpl*(FCImpl*));

  LFCMetaCatalog::LFCMetaCatalog(FCImpl* fc) : FCMetaImpl(fc)
  {
  }

  LFCMetaCatalog::~LFCMetaCatalog()
  {
  }
  
  void LFCMetaCatalog::insertMetaData(MetaDataEntry __attribute__((unused)) &mentry) const {
    //coral::MessageStream fclog( "LFCMetaCatalog::insertMetaData");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }

  void LFCMetaCatalog::createMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef) const {
    //coral::MessageStream fclog( "LFCMetaCatalog::createMetaDataSpec");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }

  void LFCMetaCatalog::updateMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef, const FileCatalog::MetaUpdateMode __attribute__((unused)) metamode) const {
    //coral::MessageStream fclog( "LFCMetaCatalog::updateMetaDataSpec");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }

  void LFCMetaCatalog::getMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef) const {
    //coral::MessageStream fclog( "LFCMetaCatalog::getMetaDataSpec");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }

  void LFCMetaCatalog::dropMetaDataSpec() const {
    //coral::MessageStream fclog( "LFCMetaCatalog::dropMetaDataSpec");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }

  void LFCMetaCatalog::deleteMetaData(const FileCatalog::FileID __attribute__((unused)) &guid) const {
    //coral::MessageStream fclog( "LFCMetaCatalog::deleteMetaData");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;
  }
  
  //functions for bulk query
    
  bool LFCMetaCatalog::retrievePFN(const std::string& query, FCBuf<PFNEntry>& buf, const size_t& start ) {
    return m_fc->retrievePFN(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveLFN(const std::string& query, FCBuf<LFNEntry>& buf, const size_t& start ) {
    return m_fc->retrieveLFN(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveGuid(const std::string& query, FCBuf<FileCatalog::FileID>& buf, const size_t& start ) {
    return m_fc->retrieveGuid(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveMetaData(const std::string __attribute__((unused)) &query, FCBuf<MetaDataEntry> __attribute__((unused)) &buf, const size_t __attribute__((unused)) &start ) {
    //coral::MessageStream fclog( "LFCMetaCatalog::retrieveMetaData");
    //fclog<<coral::Warning<<"no metadata catalog available"<<coral::MessageStream::endmsg;

    return false;
  }
}
