#include<cppunit/extensions/HelperMacros.h>

#include "LFCCatalog/LFCCatalog.h"
#include "FileCatalog/FCImpl.h"
#include "FileCatalog/FCCommon.h"
#include "FileCatalog/IFileCatalog.h"

class ConnectionTest: public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE (ConnectionTest);
  //CPPUNIT_TEST (testGenericConnect);
  CPPUNIT_TEST (testDirectConnect);
  CPPUNIT_TEST_SUITE_END ();
  
public:
  pool::IFileCatalog *lfc;
  
  
  void setUp() {
  }

  void tearDown() {
  }

  void testGenericConnect() {
    lfc = new pool::IFileCatalog;
    lfc->setWriteCatalog("lfccatalog_lfc://lfc-dteam-test.cern.ch");
    std::cout<<"[OVAL]TEST --> testGenericConnect"<<std::endl;
    try{
      lfc->connect();
      lfc->start();

      lfc->commit(); 
      lfc->disconnect();
    }catch(const pool::Exception& er){
      std::cerr << er.what() << std::endl;
    } catch ( ... ) {
      std::cerr << "Unknown exception..." << std::endl;
    }
    if (lfc != 0) 
      delete lfc;
  }
  
  void testDirectConnect() {
    try {
      std::cout<<"[OVAL]TEST --> testDirectConnect"<<std::endl;
      pool::LFCCatalog lfc;
      lfc.setURL("lfc://lfc-dteam-test.cern.ch");
      lfc.setType("lfccatalog");
      lfc.connect();
      lfc.start();
      
      lfc.commit();
      lfc.disconnect();
    } catch ( pool::Exception& e ) {
      std::cerr << e.what() << std::endl;
    } catch ( ... ) {
      std::cerr << "Unknown exception..." << std::endl;
    }
  }

  
};
CPPUNIT_TEST_SUITE_REGISTRATION(ConnectionTest);
#include<CppUnit_testdriver.cpp>
