#ifndef OBJECTRELATIONALACCESS_OBJECTRELATIONALTABLEREGISTER_H
#define OBJECTRELATIONALACCESS_OBJECTRELATIONALTABLEREGISTER_H

#include <string>
#include <set>
#include <map>

namespace pool {

  class ObjectRelationalTableRegister {
    
    public:

    ObjectRelationalTableRegister();

    virtual ~ObjectRelationalTableRegister();

    bool checkTable(const std::string& tableName);

    bool checkColumn(const std::string& tableName, const std::string& columnName);

    size_t numberOfColumns(const std::string& tableName);

    void insertTable(const std::string& tableName);

    bool insertColumn(const std::string& tableName, const std::string& columnName);

    private:

    std::map<std::string,std::set<std::string> > m_register;

    const std::string* m_currentTable;

    std::set<std::string>* m_currentColumns;
    
  };

}

#endif
