#ifndef OBJECTRELATIONALACCESS_TABLEDESCRIPTIONSTACK_H
#define OBJECTRELATIONALACCESS_TABLEDESCRIPTIONSTACK_H

#include <string>
#include <vector>
#include <map>

namespace coral {

  class TableDescription;
  
}

namespace pool {
  
  namespace ObjectRelationalAccess {

    class TableDescriptionStack
    {
    public:
      TableDescriptionStack();
      ~TableDescriptionStack();
      coral::TableDescription& description( const std::string& tableName );
      const coral::TableDescription& description( const std::string& tableName ) const;
      typedef std::vector< std::string >::const_iterator const_iterator;
      const_iterator begin() const;
      const_iterator end() const;
    private:
      std::vector< std::string > m_tableNames;
      std::map< std::string, coral::TableDescription* > m_descriptions;
    };

  }

}

#endif
