#ifndef DUMMYSCHEMA_H
#define DUMMYSCHEMA_H

#include "RelationalAccess/ISchema.h"

class DummySchema : virtual public coral::ISchema {

public:
  DummySchema();
  virtual ~DummySchema();

  std::string schemaName() const;

  std::set<std::string> listTables() const;
  bool existsTable( const std::string& name ) const;
  coral::ITable& createTable( const coral::ITableDescription& description );
  void dropTable( const std::string& name );
  void truncateTable( const std::string& name );
  void dropIfExistsTable( const std::string& name );
  coral::ITable& tableHandle( const std::string& name );
  void callProcedure( const std::string& name, const coral::AttributeList& input );
  coral::IQuery* newQuery() const;
  coral::IViewFactory* viewFactory();
  bool existsView(const std::string&) const;
  void dropView(const std::string&);
  void dropIfExistsView(const std::string&);
  std::set<std::string> listViews() const;
  coral::IView& viewHandle(const std::string&);
private:
  std::set<std::string> m_listOfTables;
};

#endif
