#ifndef RELATIONALFILECATALOG_QUERYHOLDER_H
#define RELATIONALFILECATALOG_QUERYHOLDER_H


namespace coral {
  class IQuery;
  class ICursor;
}

namespace pool {

  namespace RelationalFileCatalog {

    /// Helper class to hold a cursor with the query.

    class QueryHolder {
    public:
      /// Constructor
      explicit QueryHolder( coral::IQuery* query );

      /// Destructor
      ~QueryHolder();

      /// Returns the cursor
      coral::ICursor& cursor();

    private:
      /// The query object
      coral::IQuery* m_query;

      /// The cursor reference
      coral::ICursor& m_cursor;
    };

  }

}


#include "RelationalAccess/IQuery.h"
#include "RelationalAccess/ICursor.h"

inline
pool::RelationalFileCatalog::QueryHolder::QueryHolder( coral::IQuery* query ):
  m_query( query ),
  m_cursor( m_query->execute() )
{}

inline
pool::RelationalFileCatalog::QueryHolder::~QueryHolder()
{
  delete m_query;
}

inline coral::ICursor&
pool::RelationalFileCatalog::QueryHolder::cursor()
{
  return m_cursor;
}

#endif
