#include <iostream>
#include <stdexcept>
#include <memory>
#include <cstdlib>

#include "FileCatalog/IFileCatalog.h"
#include "FileCatalog/URIParser.h"

void resetCatalog( const std::string& databaseConnection );

int main( int, char** )
{
  try {
    char my_arg1[] = "CORAL_AUTH_USER=ral_writer";
    char my_arg2[] = "CORAL_AUTH_PASSWORD=ral";
      
    ::putenv( my_arg1 );
    ::putenv( my_arg2 );

    const std::string databaseConnection = "oracle://devdb10/ral_writer";

    resetCatalog( databaseConnection );

    pool::IFileCatalog fileCatalog;
    pool::URIParser p( "relationalcatalog_" + databaseConnection );
    p.parse();

    fileCatalog.setWriteCatalog( p.contactstring() );
    fileCatalog.connect();
    fileCatalog.start();

    fileCatalog.commit();
    fileCatalog.disconnect();
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Unknown exception..." << std::endl;
    return 1;
  }
  return 0;
} 
