#include "CArrayHandler.h"
#include "CArrayIteratorHandler.h"
#include "RelationalStorageServiceException.h"
#include "ObjectRelationalAccess/ObjectRelationalClassUtils.h"

pool::RelationalStorageService::CArrayHandler::CArrayHandler( const TypeH& dictionary ):
  m_type( dictionary ),
  m_elementType()
{

  // find the iterator return type 
  TypeH elementType = m_type.ToType();
  m_elementType = ObjectRelationalClassUtils::resolvedType( elementType );
  
}

pool::RelationalStorageService::CArrayHandler::~CArrayHandler(){
}

size_t
pool::RelationalStorageService::CArrayHandler::size( const void* )
{
  return m_type.ArrayLength();
}


pool::RelationalStorageService::IContainerIteratorHandler*
pool::RelationalStorageService::CArrayHandler::iterate( const void* address )
{
  return new pool::RelationalStorageService::CArrayIteratorHandler( address, m_elementType );
}


void
pool::RelationalStorageService::CArrayHandler::appendNewElement( void*, void* )
{
}

void
pool::RelationalStorageService::CArrayHandler::clear( const void* )
{
}

TypeH
pool::RelationalStorageService::CArrayHandler::iteratorReturnType() const
{
  return m_elementType;
}
