#ifndef ICONTAINER_ITERATOR_HANDLER_H
#define ICONTAINER_ITERATOR_HANDLER_H

#include "Reflex/Type.h"
#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
 typedef ROOT::Reflex::Type TypeH;
#else
 typedef Reflex::Type TypeH;
#endif
 
namespace pool {

  namespace RelationalStorageService {

    class IContainerIteratorHandler {
    public:
      /// Destructor
      virtual ~IContainerIteratorHandler() {}

      /// Increments itself
      virtual void increment() = 0;

      /// Returns the current object
      virtual void* object() = 0;

      /// Returns the return type of the iterator dereference method
      virtual TypeH returnType() const = 0;
    };

  }

}

#endif
