#include "RelationalStorageServiceNames.h"
#include <locale>
#include <sstream>

std::string
pool::RelationalStorageService::serviceName(){
  static std::string serviceName = "POOL/RelationalStorageService";
  return serviceName;
}

// The top level table
std::string
pool::RelationalStorageService::RelationalStorageServiceNames::topLevelDatabaseTableName()
{
  return "POOL_RSS_DB";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::guidVariableNameInTopLevelDatabaseTable()
{
  return "GUID";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::numberOfContainersVariableNameInTopLevelDatabaseTable()
{
  return "NUMBER_OF_CONTAINERS";
}


// The table holding the container headers

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::containerHeaderTableName()
{
  return "POOL_RSS_CONTAINERS";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::idVariableNameInContainerHeaderTable()
{
  return "CONTAINER_ID";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::containerNameVariableNameInContainerHeaderTable()
{
  return "CONTAINER_NAME";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::containerTypeVariableNameInContainerHeaderTable()
{
  return "CONTAINER_TYPE";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::tableNameVariableNameInContainerHeaderTable()
{
  return "TABLE_NAME";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::classNameVariableNameInContainerHeaderTable()
{
  return "CLASS_NAME";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::mappingVersionVariableNameInContainerHeaderTable()
{
  return "MAPPING_VERSION";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::numberOfWrittenObjectsVariableNameInContainerHeaderTable()
{
  return "NUMBER_OF_WRITTEN_OBJECTS";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::numberOfDeletedObjectsVariableNameInContainerHeaderTable()
{
  return "NUMBER_OF_DELETED_OBJECTS";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::primitivesContainerTypeValueInContainerHeaderTable()
{
  return "Homogeneous (Primitive)";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::homogeneousContainerTypeValueInContainerHeaderTable()
{
  return "Homogeneous";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::polymorphicContainerTypeValueInContainerHeaderTable()
{
  return "Polymorphic";
}


// The table corresponding to a polymorphic container

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::oidVariableNameInPolymorphicContainerTable()
{
  return "OID";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::classNameVariableNameInPolymorphicContainerTable()
{
  return "CLASS_NAME";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::mappingVersionVariableNameInPolymorphicContainerTable()
{
  return "MAPPING_VERSION";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::targetOIDVariableNameInPolymorphicContainerTable()
{
  return "TARGET_OID";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::tableNameForContainer( const std::string& containerName )
{
  std::ostringstream os;
  os << "POOL_CONT_";
  for ( std::string::size_type i = 0; i < containerName.size(); ++i ) {
    char c = std::toupper( containerName[i], std::locale::classic() );
    if ( c == '#' ) c = '_'; // The # character is not allowed in some databases.
    os << c;
  }
  return os.str();
}



// The table corresponding to an homogeneous container of primitive types

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::idVariableNameInPrimitivesContainerTable()
{
  return "OID";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::dataVariableNameInPrimitivesContainerTable()
{
  return "VALUE";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::mappingVersionProperty()
{
  static std::string s_propertyName("mapping_version");
  return s_propertyName;
}

// The table holding the sequences used for the polymorphic containers

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::sequencesTableName()
{
  return "POOL_RSS_SEQ";
}


std::string
pool::RelationalStorageService::RelationalStorageServiceNames::nameVariableInSequencesTableName()
{
  return "NAME";
}


std::string
pool::RelationalStorageService::RelationalStorageServiceNames::valueVariableInSequencesTableName()
{
  return "VALUE";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::linksContainerName(){
  return "__LINKS";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::shapesContainerName(){
  return "__SHAPES";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::paramsContainerName(){
  return "__PARAMS";
}

std::string
pool::RelationalStorageService::RelationalStorageServiceNames::polyPtrNullLabel(){
  return "pool::PolyPtr::Null";
}
