#ifndef POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H
#define POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H

#include "RootStorageSvc/ICINTStreamer.h"
#include "Reflex/PluginService.h"
#include "Reflex/Type.h"
#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
namespace {
  template < typename P > class Factory<P, pool::ICINTStreamer*(ROOT::Reflex::Type)> {
  public: static void* Func( void*, const std::vector<void*>& arg, void*) 
    { return (pool::ICINTStreamer*)(new P(*(ROOT::Reflex::Type*)arg[0]));   }
  };
}
#define DECLARE_CINTSTREAMER(x) PLUGINSVC_FACTORY(x,pool::ICINTStreamer*(ROOT::Reflex::Type))
#else
namespace {
  template < typename P > class Factory<P, pool::ICINTStreamer*(Reflex::Type)> {
  public: static void* Func( void*, const std::vector<void*>& arg, void*) 
    { return (pool::ICINTStreamer*)(new P(*(Reflex::Type*)arg[0]));   }
  };
}
#define DECLARE_CINTSTREAMER(x) PLUGINSVC_FACTORY(x,pool::ICINTStreamer*(Reflex::Type))
#endif

#endif // POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H
