#ifndef POOL_RULESDTDRESOLVER_H
#define POOL_RULESDTDRESOLVER_H

//--------------------------------------------------------------------------
// File and Version Information:
// 	$Id: RulesDTDResolver.h,v 1.2 2008/02/29 10:02:36 witoldp Exp $
//
// Description:
//	Class Template.
//
// Environment:
//      This software was developed for the ATLAS collaboration.  If you
//      use all or part of it, please give an appropriate acknowledgement.
//
//------------------------------------------------------------------------

//-----------------
// C/C++ Headers --
//-----------------

//----------------------
// Base Class Headers --
//----------------------
#include "xercesc/sax/EntityResolver.hpp"

//-------------------------------
// Collaborating Class Headers --
//-------------------------------

//------------------------------------
// Collaborating Class Declarations --
//------------------------------------

//		---------------------
// 		-- Class Interface --
//		---------------------


/**
 *  SAX entity resolver for the DTD
 *
 *  This software was developed for the ATLAS collaboration.  If you
 *  use all or part of it, please give an appropriate acknowledgement.
 *
 *  @see RulesFileCatalog
 *
 *  @version $Id: RulesDTDResolver.h,v 1.2 2008/02/29 10:02:36 witoldp Exp $
 *
 *  @author Andy Salnikov
 */

namespace pool {

class RulesDTDResolver : public xercesc::EntityResolver {
public:

  // Constructors
  RulesDTDResolver() ;

  // Destructor
  virtual ~RulesDTDResolver() ;

  // implementation of the resolver method
  virtual xercesc::InputSource* resolveEntity ( const XMLCh* const publicId, 
                                                const XMLCh* const systemId ) ;

protected:

  // Helper functions

private:

  // Friends

  // Data members

  // Note: if your class needs a copy constructor or an assignment operator, 
  //  make one of the following public and implement it.
  RulesDTDResolver( const RulesDTDResolver& );                // Copy Constructor
  RulesDTDResolver& operator= ( const RulesDTDResolver& );    // Assignment op

};

} // namespace pool

#endif // POOL_RULESDTDRESOLVER_H
