//====================================================================
//
//  Package    : StorageSvc (The POOL project)
//
//  Author     : M.Frank
//====================================================================
#ifndef POOL_STORAGESVC_IIOHANDLERFACTORY_H
#define POOL_STORAGESVC_IIOHANDLERFACTORY_H

#include "Reflex/PluginService.h"
#include "StorageSvc/IIOHandler.h"
#include "RVersion.h"
#if ROOT_VERSION_CODE > ROOT_VERSION(5,18,0)
namespace {
  template < typename P > class Factory<P, pool::IIOHandler*(Reflex::Type)> {
    public: static void* Func(void*,const std::vector<void*>& arg,void*) 
    { return (pool::IIOHandler*)new P(*(Reflex::Type*)arg[0]);   }
  };
}
#define DECLARE_IOHANDLER(x) PLUGINSVC_FACTORY(x,pool::IIOHandler*(Reflex::Type))

#else
namespace {
  template < typename P > class Factory<P, pool::IIOHandler*(ROOT::Reflex::Type)> {
    public: static void* Func(void*,const std::vector<void*>& arg,void*) 
    { return (pool::IIOHandler*)new P(*(ROOT::Reflex::Type*)arg[0]);   }
  };
}
#define DECLARE_IOHANDLER(x) PLUGINSVC_FACTORY(x,pool::IIOHandler*(ROOT::Reflex::Type))

#endif

#endif // POOL_STORAGESVC_IIOHANDLERFACTORY_H
