// Package pool/POOLCore
//#include "POOLCore/POOLContext.h"
//#include "CoralBase/MessageStream.h"
#include "Reflex/Type.h"
#include "POOLCore/Reference.h"
#include "POOLCore/Token.h"
#include "POOLCore/Guid.h"

// Package pool/StorageSvc - interfaces
#include "StorageSvc/IStorageSvc.h"
#include "StorageSvc/IIOHandler.h"
#include "StorageSvc/IOODatabase.h"
#include "StorageSvc/IDbCursor.h"
#include "StorageSvc/IDbContainer.h"
#include "StorageSvc/IDbDatabase.h"
#include "StorageSvc/IDbDomain.h"
#include "StorageSvc/IDbSession.h"
#include "StorageSvc/IClassHandler.h"
#include "StorageSvc/IClassLoader.h"
#include "StorageSvc/IDbOptionProxy.h"
#include "StorageSvc/FileDescriptor.h"

// Package pool/StorageSvc - implementation
#include "StorageSvc/DbArray.h"
#include "StorageSvc/DbBlob.h"
#include "StorageSvc/DbOption.h"
#include "StorageSvc/DbMemoryIO.h"
#include "StorageSvc/DbCallBack.h"
#include "StorageSvc/DbDefaultDataHandler.h"
#include "StorageSvc/DbObjectCallBack.h"
#include "StorageSvc/DbObjectGuard.h"
#include "StorageSvc/DbClassHandler.h"
#include "StorageSvc/DbClassLoader.h"
#include "StorageSvc/DbConnection.h"

#include "StorageSvc/DbObject.h"
#include "StorageSvc/DbContainer.h"
#include "StorageSvc/DbDatabase.h"
#include "StorageSvc/DbDomain.h"
#include "StorageSvc/DbSession.h"

#include "StorageSvc/DbTransaction.h"
#include "StorageSvc/DbReflex.h"
#include "StorageSvc/DbSelect.h"
#include "StorageSvc/DbOption.h"
#include "StorageSvc/DbHeap.h"
#include "StorageSvc/DbColumn.h"
#include "StorageSvc/DbTypeInfo.h"

namespace pool {
  class StorageSvc {
    StorageSvc() {}
    virtual ~StorageSvc() {}
    std::string package()  const { return "StorageSvc"; }
    std::string author()  const  { return "M.Frank CERN/LHCb"; }
  };
}

namespace {
  class dummy {
  public:
    pool::DbArray<char>            m__c_array;
    pool::DbArray<unsigned char>   m_uc_array;
    pool::DbArray<short>           m__s_array;
    pool::DbArray<unsigned short>  m_us_array;
    pool::DbArray<int>             m__i_array;
    pool::DbArray<unsigned int>    m_ui_array;
    pool::DbArray<long>            m__l_array;
    pool::DbArray<unsigned long>   m_ul_array;
    pool::DbArray<float>           m__f_array;
    pool::DbArray<double>          m__d_array;
    //pool::DatabaseConnectionPolicy m_policy;
  };
}
