#ifndef DataModel_H
#define DataModel_H

#include <utility>
#include "DataSvc/Ref.h"

namespace ext {

  template <typename T> struct Base {
    Base(){}
    virtual ~Base(){}
    virtual T obj()=0;
  };

  template <typename T> struct B : public Base<T> {
    T o;
    B(){}
    B(T t) : o(t){}
    virtual ~B(){}
    B(const B<T>& b): Base<T>(),o(b.o){}
    B& operator=(const B<T>& b){
      o = b.o;
      return *this;
    }
    T obj(){
      return o;
    }
  };

  struct C {
    C(): d(0){}
    C(int i): d(i){}
    virtual ~C(){}
    int d;
  };

  struct A {
    A(){
      C tmp(0);
      p.first = tmp;
      pool::Ref<Base<int> > rtmp;
      p.second = rtmp;
    }
    A(int i) {
      C tmp(i);
      p.first = tmp;
      pool::Ref<Base<int> > rtmp;
      p.second = rtmp;
    }
    A(const A& a){
      p.first = a.p.first;
      p.second= a.p.second;
    }
    A& operator=(const A& a){
      p.first = a.p.first;
      p.second= a.p.second;
      return *this;
    }
    virtual ~A(){}
    std::pair<C,pool::Ref<Base<int> > > p;
  };


}  
#endif
