#include "DataRegression_CollectionBase/CollectionRegressionTestDriver.h"
#include "POOLCore/Exception.h"

using namespace pool;
using namespace std;

int main(int argn, char** args){
  
  const string collName = "testCollection";
  const string collConnection = "./data/";
  const string collType = "RootCollection";
  const int howmany = 10;
  
  bool read = 0;
  bool write = 0;
  if(argn==2)
    if(!strcmp(args[1],"R"))
      read = 1;
    else if(!strcmp(args[1],"W"))
      write = 1;
  
  if(!(read || write)){
    std::cout << "please provide exactly one argument: 'R' for read mode or 'W' for writing\n";
    return 1;
  }
  

  CollectionRegressionTestDriver driver;
  try {
    
    if(write)
      driver.writeFlat( collName,
			collConnection,
			collType,
			howmany );
    
    if(read)
      driver.readObjects( collName,
		   collConnection,
		   collType );
    
  }catch(pool::Exception& e)   {
    std::cout << "The test has thrown an exception:" << e.what() << std::endl;
    driver.addError();
  }
  catch (std::exception& e){
    std::cerr << "test ERROR:" << e.what() << "\n";
    driver.addError();
  }catch(...){
    std::cout << "The test has thrown an unknown exception." << std::endl;
    driver.addError();
  }
  driver.dumpError();
}
  


