#include "DataSvc/Ref.h"
#include <vector>
#include <iostream>

namespace NavigationTests {

struct CCInfo {
  static pool::IDataSvc* ccCache(pool::IDataSvc* c=0)  {
    static pool::IDataSvc* cc = 0;
    if ( c != 0 ) cc = c;
    return cc;
  }
};

template <class T> class CCRef : public pool::Ref<T>,virtual public CCInfo {
 public:
  CCRef(): pool::Ref<T>(CCInfo::ccCache()) {}
  CCRef(const CCRef<T>& aCCRef): pool::Ref<T>(aCCRef){}
  CCRef<T>& operator=(const CCRef<T>& aCCRef){
    pool::Ref<T>::operator=(aCCRef);
    return *this;
  }
  CCRef<T>& operator=(const pool::Ref<T>& aRef){
    pool::Ref<T>::operator=(aRef);
    return *this;
  }
};

struct CBase {
  virtual ~CBase(){}

  virtual void bha(){}
  int kk;

};

struct A  {
  virtual ~A(){}
};


struct CC;
struct B : public A {
  B(){}
  virtual ~B(){}
  int j;
  //pool::Ref<CC> c;
  CCRef<CC> c;
  //    CC * tc_;
};

struct CC : public A, public CBase {
  CC(){}
  virtual ~CC(){}
  virtual void bha() {}
  std::vector<pool::Ref<B> > bs;
  pool::Ref<CC> parent;
};

}

pool::Ref<NavigationTests::B> c;
