#include <iostream>
class OId  {

 private:
  long m_id;  

  static long next() 
    { static long cnt=0; return ++cnt; }

 public:

  OId():m_id(0){  
    m_id = next();
  }

  OId(long anId): m_id(anId){
  }

  OId(const OId& aId): m_id(aId.m_id){}

  virtual ~OId(){}

  long id() const {
    return m_id;
  }

};

class ObjectPtrMemberClass  {

 private:

  long m_id;
  
  static long next() 
    { static long cnt=0; return ++cnt; }

  OId* m_extId;

 public:

  ObjectPtrMemberClass(long val): m_extId(0){ 
      m_id = val;
    }

  ObjectPtrMemberClass(): m_extId(0){ 
      m_id=next();  
    }

  virtual ~ObjectPtrMemberClass(){}
 
  long id(){
    return m_id;
  }

  const OId* extId(){
    return m_extId;
  }

  void setExtId(OId* anId){
    m_extId = anId;
  }

  bool operator==(const ObjectPtrMemberClass& anObject){
    bool ret = true;
    if(m_id!=anObject.m_id)     ret = false;
    if(!m_extId){
      if(anObject.m_extId) ret = false;
    } else {
      if(!anObject.m_extId){
        ret = false;
      } else {
        if(m_extId->id() != (anObject.m_extId)->id()) ret = false;
      }
    }
    return ret;
  }

  void dump() const {
    std::cout << "Id="<<m_id<<std::endl;
    if(m_extId){
      std::cout << "Ext Id="<<m_extId->id()<<std::endl;
    }
  }

};

