#include "TestBase/TestBase.h"
#include "StorageSvc/DbType.h"
#include "StorageSvc/poolDb.h"
#include <vector>

class TestClass;

namespace pool  {

class SimpleAppendTestBase : public TestBase {
  private:
    const std::string m_dbName;
    const DbType m_type;
    std::string m_fid;
    std::vector<Token*> tokens;

    bool compareExpected(unsigned int i,const TestClass& obj);

  public: 
    SimpleAppendTestBase(std::string& dbName, const DbType& storage_type);

    /// write objects to the persistent store
    void write(unsigned int NC);

    /// read objects from the persistent store
    void reWrite(unsigned int NC);

    /// read objects from the persistent store
    void read(unsigned int n_expected);

    virtual void execute(){};

};

class SimpleAppendTest : public SimpleAppendTestBase {
    public: 
    SimpleAppendTest(std::string& dbName, const DbType& storage_type)
          :SimpleAppendTestBase(dbName,storage_type){}

    void execute(){
      write(500);
      reWrite(500);
      read(1000);
    }

  };

  class SimpleWriteTest : public SimpleAppendTestBase {
    public: 
    SimpleWriteTest(std::string& dbName, const DbType& storage_type)
          :SimpleAppendTestBase(dbName,storage_type){}

    void execute(){
      write(500);
      read(500);
    }

  };

  class SimpleReWriteTest : public SimpleAppendTestBase {
    public: 
    SimpleReWriteTest(std::string& dbName, const DbType& storage_type)
          :SimpleAppendTestBase(dbName,storage_type){}

    void execute(){
      reWrite(500);
    }

  };  

  class SimpleReadTest : public SimpleAppendTestBase {
    public: 
    SimpleReadTest(std::string& dbName, const DbType& storage_type)
          :SimpleAppendTestBase(dbName,storage_type){}

    void execute(){
      read(1000);
    }

};

}



