#include "ObjectStorageTest/ObjectStorageTest.h"
#include "FileCatalog/IFileCatalog.h"

namespace pool  {

  class SimpleMultiBackendsTest : public ObjectStorageTest {

    public: 
    SimpleMultiBackendsTest(std::string& dbName1, const DbType& storage_type1,
                            std::string& dbName2, const DbType& storage_type2)
     :ObjectStorageTest(dbName1,storage_type1,dbName2,storage_type2){}

    void execute(){
      write(1000);
      read(1000,"WRITE");
      update(1000);
      read(1000,"UPDATE");
      erase(1000,"UPDATE");
      read(0,"DELETE");
    }
  };

}

int main(int, char**)     {
  typedef pool::SimpleMultiBackendsTest Test;
  std::string f1 = "test1.root";
  std::string f2 = "sqlite_file:mytest.db";
  Test theTest(f1, pool::ROOTKEY_StorageType,
               f2, pool::POOL_RDBMS_StorageType);
  theTest.run();
  return 0;
}

