#ifndef CATALOGLOOKUPS_H
#include "CMSFileManagerBase/CatalogLookups.h"
#endif
#include "FileCatalog/IFileCatalog.h"
#include "FileCatalog/IFCAction.h"
#include "FileCatalog/IFCContainer.h"
CatalogLookups::CatalogLookups(){}
CatalogLookups::~CatalogLookups(){
  if(m_catalog!=0){
    delete m_catalog;
  }
}
void CatalogLookups::openCatalog( const std::string& contactstr ){
  m_catalog=new pool::IFileCatalog;
  m_catalog->setWriteCatalog(contactstr);
  m_catalog->connect();
}
void CatalogLookups::closeCatalog(){
  m_catalog->disconnect();
}

void CatalogLookups::getMETAfiles( const std::string& DataType, const std::string& ownername, std::vector<std::string>& lfns ) const {
  pool::LFNContainer lfnentrys(m_catalog);
  pool::FClookup l;
  m_catalog->setAction(l);
  m_catalog->start();
  std::string querystr=std::string("FileCategory='META'");
  if( !DataType.empty() ){
    querystr+=std::string(" AND DataType=")+"'"+DataType+"'";
  }
  if( !ownername.empty() ){
    querystr+=std::string(" AND owner=")+"'"+ownername+"'";
  }
  l.lookupLFNByQuery(querystr,lfnentrys);
  while( lfnentrys.hasNext() ){
    lfns.push_back( (lfnentrys.Next()).lfname() );
  }
  m_catalog->commit(pool::FileCatalog::ONHOLD);
}
void CatalogLookups::getEVDfiles( const std::string& ownername, const std::string& datasetname , const std::string& evdtype,std::vector<std::string>& lfns ) const {
  pool::LFNContainer lfnentrys(m_catalog);
  std::string querystr=std::string("FileCategory='EVD'");
  if( !ownername.empty() ){
    querystr+=std::string(" AND owner=")+"'"+ownername+"'";
  }
  if( !datasetname.empty() ){
    querystr+=std::string(" AND dataset=")+"'"+datasetname+"'";
  }
  if( !evdtype.empty() ){
    querystr+=std::string(" AND DataType=")+"'"+evdtype+"'";
  }
  pool::FClookup l;
  m_catalog->setAction(l);
  m_catalog->start();
  l.lookupLFNByQuery(querystr,lfnentrys);
  while( lfnentrys.hasNext() ){
    lfns.push_back( (lfnentrys.Next()).lfname() );
  }
  m_catalog->commit(pool::FileCatalog::ONHOLD);
}
void CatalogLookups::getOtherfiles( const std::string& filecategory, const std::string& owner,std::vector<std::string>& lfns) const {
  pool::LFNContainer lfnentrys(m_catalog);
  m_catalog->start();
  std::string fc;
  if( !filecategory.empty() ){
    fc=std::string("FileCategory=")+"'"+filecategory+"'";
    if ( !owner.empty() ){
      fc+=std::string(" AND owner=")+"'"+owner+"'";
    }
  }else if ( !owner.empty() ){
    fc=std::string("owner=")+"'"+owner+"'";
  }
  pool::FClookup l;
  m_catalog->setAction(l);
  l.lookupLFNByQuery(fc,lfnentrys);
  while( lfnentrys.hasNext() ){
    lfns.push_back( (lfnentrys.Next()).lfname());
  }
  m_catalog->commit(pool::FileCatalog::ONHOLD);
} 

void CatalogLookups::getFilesByOwner( const std::string& owner,std::vector<std::string>& lfns ) const{
  pool::LFNContainer lfnentrys(m_catalog);
  m_catalog->start();
  std::string fc;
  if( !owner.empty() ){
    fc=std::string("owner=")+"'"+owner+"'";
  }
  pool::FClookup l;
  m_catalog->setAction(l);
  l.lookupLFNByQuery(fc,lfnentrys);
  while( lfnentrys.hasNext() ){
    lfns.push_back( (lfnentrys.Next()).lfname());
  }
  m_catalog->commit(pool::FileCatalog::ONHOLD);
}

