#ifndef COLLECTIONREGRESSIONTESTDRIVER_H
#define COLLECTIONREGRESSIONTESTDRIVER_H

#include "TestBase/TestKernel.h"
#include "CollectionBase/ICollection.h"
#include <iostream>

namespace pool{
  
  class Token;
  class AttributeList;
  
  
  struct CollectionRegressionTestDriver : public TestKernel {
    
    CollectionRegressionTestDriver();
    
    virtual ~CollectionRegressionTestDriver();
    
    void readObjects(const std::string& name,
		     const std::string& connection,
		     const std::string& type);
    
    void readCollections(const std::string& name,
			 const std::string& connection,
			 const std::string& type);
    
    void writeFlat( const std::string& name,
		    const std::string& connection,
		    const std::string& type,
		    const int& howmany);
    
    void writeMulti( const std::string& name,
		     const std::string& connection,
		     const std::string& type,
		     const int& howmany); 
    
    void printAttributeList(const AttributeList& al, std::ostream& os);
    
  private:
    
    ICollection* createCollection(const std::string& name,
				  const std::string& connection,
				  const std::string& type,
				  const ICollection::OpenMode& mode);
    
    void fakeTokenAndAttributeList();
    
    Token* m_token;
    AttributeList* m_attributeList;
    
  };

  

}

#endif
