#include "SealBase/Signal.h"
#include "SealBase/ProcessInfo.h"
#include "PoolBench/ProcessInfo.h"

#include <string>
#include <sstream>
#include <iostream>
#include <iomanip>

#include <cstdio>
#include <unistd.h>

using namespace pool;

#define ALLOC_MEM_STEP 8192

int main (
  int /*argc*/,
  char** /*argv*/
  )
{
  size_t pageSize = getpagesize();
  
  std::cout << "Initial memory status of this process:" << std::endl;
  std::cout << "Process page size is    : " << pageSize                          << std::endl;
  std::cout << "Process pid is          : " << seal::ProcessInfo::pid()          << std::endl;
  
  ProcessInfo::update();
  std::cout << "Process total size      : " << ProcessInfo::memSize()/1024  << " KB" << std::endl;
  std::cout << "Process resident size   : " << ProcessInfo::memRSS()/1024 << " KB" << std::endl;
  
  std::cout << "Allocating " << ALLOC_MEM_STEP << " bytes" << std::endl;
  char* wasteBytes = new char[ALLOC_MEM_STEP];

  std::cout << "Updated memory status of this process:" << std::endl;
  ProcessInfo::update();
  std::cout << "Process total size      : " << ProcessInfo::memSize()/1024   << " KB" << std::endl;
  std::cout << "Process resident size   : " << ProcessInfo::memRSS()/1024 << " KB" << std::endl;
  
  std::cout << "Allocating " << ALLOC_MEM_STEP*ALLOC_MEM_STEP << " bytes" << std::endl;
  char* wasteKBytes = new char[ALLOC_MEM_STEP*ALLOC_MEM_STEP];

  std::cout << "Updated memory status of this process:" << std::endl;
  ProcessInfo::update();
  std::cout << "Process total size      : " << ProcessInfo::memSize()/1024   << " KB" << std::endl;
  std::cout << "Process resident size   : " << ProcessInfo::memRSS()/1024  << " KB"  << std::endl;

  delete [] wasteKBytes;
  delete [] wasteBytes;

  return 0;
}
