#ifndef IPERSISTENTOBJECTBUILDER_H
#define IPERSISTENTOBJECTBUILDER_H

#include "DataSvc/Ref.h"
#include "DataSvc/IDataSvc.h"
#include "StorageSvc/DbType.h"
#include <string>

/** @class IPersistentObjectBuilder IPersistentObjectBuilder.h Tests/Libraries/StressTestBase/IPersistentObjectBuilder.h
  These should contain everything required to build a single object. It is the
  builder's job to create a unique placement for each object referenced.

    @author Tim Barrass
    @date 8/5/2003
*/
class IPersistentObjectBuilder {
public:
	virtual ~IPersistentObjectBuilder() {};
  IPersistentObjectBuilder() {};
  IPersistentObjectBuilder(const IPersistentObjectBuilder& /* b */) {};

  /** clone()
    This should just return new ...(*this);
  */
  virtual IPersistentObjectBuilder* clone() const = 0;

  /** buildPersistent()
    Handles the registering of Refs with the cache
  */
  virtual void buildPersistent() = 0;

  virtual const std::string& dbName() const = 0;
  virtual const pool::DbType& storageType() const = 0;
  virtual pool::IDataSvc* context() const = 0;

private:
};

#endif  // IPERSISTENTOBJECTBUILDER_H
