#ifndef STRESSTESTTRANSACTION_H
#define STRESSTESTTRANSACTION_H

#include "Wrapper.h"
#include "IPersistentObjectBuilder.h"

#include <vector>

 /** @class StressTestTransaction StressTestTransaction.h Tests/Libraries/StressTestBase/StressTestTransaction.h

    StressTestTransaction provides a simple abstraction of a POOL db transaction.
    All necessary information for the transaction is extracted from the builder objects passed.
    Placement creation is the responsibility of the builder objects: thus each builder object
    could be sent to a different file, container, storage type...

    @author Tim Barrass
    @date 8/5/2003
*/
class StressTestTransaction {
public:
  StressTestTransaction() {}
  virtual ~StressTestTransaction() {}

  /** write()
    Registers the Refs stored in Builder objects with the cache for writing.
  */
  void write(std::vector<PtrWrapper<IPersistentObjectBuilder> >& builders);
private:
};

#endif // STRESSTESTTRANSACTION_H

