#include "StressTestBase/SimpleAsciiCollection.h"
//#include "StressTestBase/StressTestMessageSvc.h"
//#include "SealKernel/MsgStream.h"

#include "CoralBase/MessageStream.h"

// declare these in file scope via anon namespace
namespace {
  //pool::StressTestMessageSvc m_msg("MsgSvc",0);
  //seal::MsgStream collLog(&m_msg, "SimpleAsciiCollection");
	coral::MessageStream collLog("SimpleAsciiCollection");
}

pool::SimpleAsciiCollection::SimpleAsciiCollection()
{
  m_collectionFile = "DefaultAsciiCollection.txt";
  collLog << coral::Verbose << "Using default collection \"DefaultAsciiCollection.txt\"" << coral::MessageStream::endmsg;
}



pool::SimpleAsciiCollection::SimpleAsciiCollection(std::string nuCollectionFile)
{
  m_collectionFile = nuCollectionFile;
  collLog << coral::Verbose << "Using collection \"" << m_collectionFile << "\"" << coral::MessageStream::endmsg;
}



int pool::SimpleAsciiCollection::add(std::string nuToken)
{
  collLog << coral::Verbose << "Adding this token to collection: \n" << nuToken << coral::MessageStream::endmsg;
  m_collection.push_back(nuToken);
  return 0;
}



int pool::SimpleAsciiCollection::read()
{
  char buffer[1024];
  std::ifstream coll (m_collectionFile.c_str(),std::ios::in);
  if (coll.bad()) {
    collLog << coral::Error << "Error opening file for read" << coral::MessageStream::endmsg;
  }


  while(!coll.getline(buffer, sizeof(buffer)).eof()) {
    std::cout << buffer << '\n' ;
    std::string s(buffer);
    m_collection.push_back(s);
  }
  coll.close();

  return 0;
}



int pool::SimpleAsciiCollection::write()
{
  collLog << coral::Verbose << "Writing to collection " << m_collectionFile << coral::MessageStream::endmsg;
  std::ofstream coll (m_collectionFile.c_str(),std::ios::out);
  std::vector<std::string>::iterator iter;
  if (!coll.bad())
  {
    for (iter = m_collection.begin(); iter != m_collection.end(); iter++) {
      coll << *iter << std::endl;
    }
  } else {
    collLog << coral::Error << "Error opening file for write" << coral::MessageStream::endmsg;
  }
  coll.close();

  return 0;
}



pool::SimpleAsciiCollection::~SimpleAsciiCollection()
{
  m_collection.clear();
}
