#include "StressTestBase/StressTestTransaction.h"
//#include "StressTestBase/StressTestMessageSvc.h"
#include "CoralBase/MessageStream.h"

//#include "SealKernel/MsgStream.h"
#include "StorageSvc/poolDb.h"
#include "PersistencySvc/ITransaction.h"
#include "PersistencySvc/ISession.h"

namespace {
  //pool::StressTestMessageSvc m_msg("MsgSvc",0);
  //seal::MsgStream transLog(&m_msg, "RootTreeTestApp");
	coral::MessageStream transLog("StressTestTransaction");
}

void StressTestTransaction::write(std::vector<PtrWrapper<IPersistentObjectBuilder> >& builders) {
  transLog << coral::Info << "Starting write phase" << coral::MessageStream::endmsg;


  std::vector<PtrWrapper<IPersistentObjectBuilder> >::iterator it = builders.begin();
    PtrWrapper<IPersistentObjectBuilder>& w = *it;
    (w()->context())->transaction().start( pool::ITransaction::UPDATE );
    for(; it != builders.end(); ++it) {
      (*it)()->buildPersistent();
    }
    (w()->context())->transaction().commit();
  transLog << coral::Info << "Ending write phase" << coral::MessageStream::endmsg;
  (w()->context())->session().disconnectAll();
}


