#
# Create the ROOT dictionaries
#
# Makes a SOMETHINGLinDef.cc from each SOMETHINGLinkDef.h 
#
# These are then compiled and put into the library
#
# 17-Jan-2003 created by stw
#

#ROOTCINT_BIN_DIR  = ${ROOTCORE_BASE}/bin
#ROOTCINT          = $(ROOTCINT_BIN_DIR)/rootcint
ROOTCINT          = rootcint

DICT_TOP          = $(LOCALTOP)/$(ClassDir)
DICT             := $(notdir $(wildcard $(DICT_TOP)/*LinkDef.h))
FILE_DICT         = $(patsubst %.h, %Dict.cpp, $(DICT))
FULL_FILE_DICT    = $(addprefix $(LOCALTOP)/$(workdir)/, $(FILE_DICT))

FILESCPP += $(FULL_FILE_DICT)

#------------------------------------------------------------------------------

preTest: $(FULL_FILE_DICT)

$(LOCALTOP)/$(workdir)/%Dict.cpp: $(DICT_TOP)/%.h 
	@echo "Generating dictionary for $(packagename):"
#@echo "DICT_TOP: $(DICT_TOP)"
#@echo "DICT : $(DICT )"
#@echo "FILE_DICT: $(FILE_DICT)"
#@echo "FULL_FILE_DICT: $(FULL_FILE_DICT)"
	eval `$(SCRAM) runtime -sh`;$(ROOTCINT) -f $@ -c -p -DGNU_SOURCE $(CPPFLAGS) $<
	mv $(@:.cpp=.h) $(@:.cpp=.h).base 
	cat $< $(@:.cpp=.h).base > $(@:.cpp=.h)
	rm -f $(@:.cpp=.h).base




