#include "IDataCache.h"
#include "TargetObject.h"

inline DataLink::DataLink() : m_key( "" )  {
  m_dataRef.setLink(static_cast<IDataLink*>(this));
}

inline DataLink::DataLink( const DataLink& rhs ):
  IDataLink( static_cast< const IDataLink& >(rhs) ),
  m_key( rhs.m_key )
{
  m_dataRef.setLink(static_cast<IDataLink*>(this));
  m_dataRef.operator=( rhs.m_dataRef );
}

inline DataLink& DataLink::operator=( const DataLink& rhs )  {
  m_key = rhs.m_key;
  m_dataRef.setLink(static_cast<IDataLink*>(this));
  m_dataRef.operator=( rhs.m_dataRef );
  return *this;
}

inline
DataLink::DataLink( IDataCache* cache, TargetObject* object ) : m_key( "" )
{
  m_dataRef.setLink(static_cast<IDataLink*>(this));
  this->setLink( cache, object );
}

inline
DataLink::DataLink(IDataCache* cache, const std::string& key) : m_key(key)
{
  m_dataRef.setLink(static_cast<IDataLink*>(this));
  m_dataRef.setCache( cache );
}

inline void
DataLink::setLink( IDataCache* cache, TargetObject* object )
{
  m_dataRef.setCache( cache );
  m_key = cache->key( object );
}

inline void DataLink::setLink( IDataCache* cache, const std::string& key )
{
  m_dataRef.setCache( cache );
  m_key = key;
}

inline TargetObject* DataLink::operator->()  {
  return this->objectPtr();
}

inline const TargetObject* DataLink::operator->() const   {
  return this->objectPtr();
}


inline TargetObject* DataLink::objectPtr()   {
  if ( ! m_dataRef.object() ) {
    if ( m_dataRef.cache() ) {
      m_dataRef.setObject( m_dataRef.cache()->lookup( m_key ) );
    }
  }
  return m_dataRef.object();
}


inline const TargetObject* DataLink::objectPtr() const  {
  if ( ! m_dataRef.object() ) {
    if ( m_dataRef.cache() ) {
      m_dataRef.setObject( m_dataRef.cache()->lookup( m_key ) );
    }
  }
  return m_dataRef.object();
}


inline const std::string& DataLink::key() const  {
  return m_key;
}

inline int DataLink::cacheLocationIndex() const  {
  return m_dataRef.cacheLocationIndex();
}
