#ifndef DATAREF_H
#define DATAREF_H

#include "POOLCore/Reference.h"
#include "IDataLink.h"

class TargetObject;
class IDataCache;

// The pool reference
class DataRef: public pool::Reference {
public:
  DataRef();
  explicit DataRef( IDataLink* dataLink );
  DataRef( const DataRef& rhs );
  DataRef& operator=( const DataRef& rhs );
  virtual ~DataRef();

  const std::string& key() const;

  void setLink(IDataLink* dataLink);

  void setCache( IDataCache* cache );
  IDataCache*   cache();

  void setCacheLocationIndex( int cacheLocationIndex );
  int  cacheLocationIndex() const;

  void setObject( TargetObject* object );
  TargetObject* object();

private:
  IDataLink*           m_dataLink;
  IDataCache*          m_cache;
  int                  m_cacheLocationIndex;
  TargetObject*        m_object;
};

#include "DataRef.inl"

#endif
