inline
DataRef::DataRef():
  pool::Reference(),
  m_dataLink( 0 ),
  m_cache( 0 ),
  m_cacheLocationIndex( 0 ),
  m_object( 0 )
{}

inline
DataRef::DataRef( IDataLink* dataLink ):
  pool::Reference(),
  m_dataLink( dataLink ),
  m_cache( 0 ),
  m_cacheLocationIndex( 0 ),
  m_object( 0 )
{}

inline
DataRef::DataRef( const DataRef& rhs ):
  pool::Reference(),
  m_dataLink( 0 ),
  m_cache( rhs.m_cache ),
  m_cacheLocationIndex( rhs.m_cacheLocationIndex ),
  m_object( rhs.m_object )
{}

inline DataRef& DataRef::operator=( const DataRef& rhs )
{
  m_cache = rhs.m_cache;
  m_cacheLocationIndex = rhs.m_cacheLocationIndex;
  m_object = rhs.m_object;
  return *this;
}

inline DataRef::~DataRef() {
}

inline void DataRef::setLink(IDataLink* dataLink)  {
  m_dataLink = dataLink;
}

inline void DataRef::setCache( IDataCache* cache )  {
  m_cache = cache;
}

inline IDataCache* DataRef::cache()  {
  return m_cache;
}

inline void DataRef::setCacheLocationIndex( int cacheLocationIndex )  {
  m_cacheLocationIndex = cacheLocationIndex;
}

inline int DataRef::cacheLocationIndex() const  {
  return m_cacheLocationIndex;
}

inline void DataRef::setObject( TargetObject* object )  {
  m_object = object;
}

inline TargetObject* DataRef::object()  {
  return m_object;
}


inline const std::string& DataRef::key() const  {
  return m_dataLink->key();
}
