#include "RefHandler.h"
#include "DataRef.h"
#include "IDataLink.h"
#include "ITokenCache.h"
#include <stdexcept>

RefHandler::RefHandler( ITokenCache& tokenCache ):
  m_tokenCache( tokenCache )
{}

RefHandler::~RefHandler()
{}

pool::DbStatus
RefHandler::saveReference( pool::Reference* pRef, pool::Token::OID_t* data )
{
  DataRef* ref = dynamic_cast< DataRef* >( pRef );
  if ( ! ref ) {
    throw std::runtime_error("Could not dynamic cast to DataRef");
    return pool::DbStatus::Error;
  }
  const std::string& key = ref->key();
  if ( key.empty() ) {
    throw std::runtime_error( "empty key at save reference" );
  }
  TargetObject* object = m_tokenCache.lookup( key );
  if ( ! object ) {
    throw std::runtime_error( "No object pointed by the link" );
    data->first = data->second = 0xFFFFFFFF;
    return pool::DbStatus::Error;
  }
  pool::Token* token = m_tokenCache.saveObject( object );
  if ( ! token ) {
    throw std::runtime_error( "Object not written" );
    data->first = data->second = 0xFFFFFFFF;
    return pool::DbStatus::Error;
  }
  pool::DbStatus sc = this->saveToken( token, data );
  return sc;
}

pool::DbStatus
RefHandler::loadReference( pool::Reference* pRef, pool::Token::OID_t* data)
{
  pool::Token *token = 0;
  pool::DbStatus sc = createToken( data, token );
  if ( sc.isSuccess() ) {
    DataRef* ref = dynamic_cast< DataRef* >( pRef );
    if ( ! ref ) {
      throw std::runtime_error("Could not dynamic cast to TheRef");
      return pool::DbStatus::Error;
    }
    ref->setCache( static_cast< IDataCache* >( &m_tokenCache ) );
    ref->setCacheLocationIndex( m_tokenCache.registerToken( token ) );
  }
  return sc;
}
