#ifndef DATALINK_H
#define DATALINK_H

#include <string>

class TargetObject;
class IDataCache;

class DataLink {
public:
  DataLink();
  DataLink( IDataCache* cache, TargetObject* object );
  DataLink( IDataCache* cache, const std::string& key );
  virtual ~DataLink(){}

  void setLink( IDataCache* cache, TargetObject* object );
  void setLink( IDataCache* cache, const std::string& key );

  TargetObject* operator->();
  const TargetObject* operator->() const;

  TargetObject*  objectPtr();
  const TargetObject*  objectPtr() const;

  const std::string& key() const;

private:
  mutable IDataCache*   m_cache;
  mutable TargetObject* m_object;
  mutable std::string   m_key;
};

#include "DataLink.inl"

#endif
