#ifndef DATAREF_H
#define DATAREF_H

#include "POOLCore/Reference.h"
#include <string>
#include <iostream>

// The base ref
class IDataRef {
public:
  virtual const std::string& key() const = 0;
  virtual ~IDataRef() {}
protected:
  IDataRef() {}
  IDataRef( const IDataRef& ) {}
};


// The pool reference
class TheRef: public pool::Reference {
public:
  TheRef(): m_ref( 0 ), m_index( 0 ) {}
  explicit TheRef( IDataRef* r ): m_ref( r ), m_index( 0 ) {}
  virtual ~TheRef() {}
  void setRef(IDataRef* r)    {    m_ref = r;         }
  IDataRef* ref() const       {    return m_ref;      } 
  void setIndex( int index )  {    m_index = index;   }
  int index() const           {    return m_index;    }
private:
  IDataRef* m_ref;
  int       m_index;
};


// The actual ref
class DataRef : virtual public IDataRef   {
public:
  DataRef() : IDataRef(), m_key("")  {
    m_ref.setRef(this);
  }
  DataRef( const DataRef& rhs )
  : IDataRef( static_cast< const IDataRef& >( rhs) ),m_key( rhs.m_key )
  {
    m_ref.setRef(this);
    m_ref.setIndex( rhs.m_ref.index() );
  }
  virtual ~DataRef() {}
  const std::string& key() const { return m_key; }

public:
  std::string     m_key;
  TheRef          m_ref;
};

#endif
