#ifndef OBJECTDATACALLBACK_H
#define OBJECTDATACALLBACK_H

#include "Reflex/Type.h"
#include "StorageSvc/DataCallBack.h"

#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
using namespace ROOT;
#endif

class ITokenCache;

class ObjectCallBack : public pool::DataCallBack
{
public:
  explicit ObjectCallBack( ITokenCache& cache );

  ~ObjectCallBack();

  pool::DataCallBack* clone() const;

  Reflex::Type transientType() const;

  void setObject( const void* ptr );

  const void* object() const;

  void setShape( const pool::Shape* shape );

  const pool::Shape* shape() const;

  void setHandler( pool::DataHandler* pSvc );

  pool::DataHandler* handler() const;

  pool::DbStatus start( pool::DataCallBack::CallType action_type,
			void* data,
			void** context);

  pool::DbStatus bind( pool::DataCallBack::CallType action_type,
		       const pool::DbColumn* col_identifier,
		       int col_number,
		       void* context,
		       void** data );

  pool::DbStatus end( pool::DataCallBack::CallType action,
		      void* context );

  pool::DbStatus notify( pool::DataCallBack::CallType action_type,
			 int data_type,
			 Reflex::Type reflection,
			 void* object_ptr,
			 void* data );
private:
  ITokenCache&                      m_cache;
  Reflex::Type                m_transientType;
  pool::DataHandler*                m_dataHandler;
  const pool::Shape*                m_shape;
  const void*                       m_transientObjectData;
  void*                             m_persistentObjectData;
};

#endif
