#include "TestTransactionObserver.h"
#include <ostream>

TestTransactionObserver::TestTransactionObserver( const std::string& name,
						  std::ostream& os ):
  m_name( name ),
  m_os( os )
{}

TestTransactionObserver::~TestTransactionObserver()
{}

bool
TestTransactionObserver::respondToStartRead()
{
  m_os << "TestTransactionObserver " << m_name << " : Responding to start of a read transaction" << std::endl;
  return true;
}
  
bool
TestTransactionObserver::respondToStartUpdate()
{
  m_os << "TestTransactionObserver " << m_name << " : Responding to start of an update transaction" << std::endl;
  return true;
}
  
bool
TestTransactionObserver::respondToCommit()
{
  m_os << "TestTransactionObserver " << m_name << " : Responding to a transaction commit" << std::endl;
  return true;
}
  
bool
TestTransactionObserver::respondToRollBack()
{
  m_os << "TestTransactionObserver " << m_name << " : Responding to a transaction rollback" << std::endl;
  return true;
}

bool
TestTransactionObserver::respondToUpdate()
{
  m_os << "TestTransactionObserver " << m_name << " : Responding to a transaction update" << std::endl;
  return true;
}
