#ifndef POOL_PRIMITIVESCONTAINERSTREAMERS_H
#define POOL_PRIMITIVESCONTAINERSTREAMERS_H

#include "POOLCore/IBlobStreamingService.h"
#include "CoralBase/Blob.h"
#include "Reflex/Type.h"
#include "RVersion.h"

#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
using namespace ROOT;
#endif

namespace pool {

  class BlobWriter : virtual public IBlobWriter
  {
  public:
    /// Constructor
    explicit BlobWriter( const Reflex::Type& type );

    /// Empty destructor
    virtual ~BlobWriter();

    /// Streams an object an returns by constant reference the underlying blob
    const coral::Blob& write( const void* addressOfInputData );

  private:
    /// The type
    Reflex::Type m_type;

    /// The blob data
    coral::Blob m_blob;
  };


  class BlobReader : virtual public IBlobReader
  {
  public:
    /// Constructor
    BlobReader( const Reflex::Type& type );

    /// Empty destructor
    virtual ~BlobReader();

    /// Reads an object from a Blob and returns the starting address of the object
    void read( const coral::Blob& blobData,
               void* containerAddress ) const;

  private:
    /// The type
    Reflex::Type m_type;
  };

}

#endif
