#include "TestBlobStreamingService.h"
#include "PrimitivesContainerStreamers.h"
#include "ObjectRelationalAccess/ObjectRelationalClassUtils.h"

pool::TestBlobStreamingService::TestBlobStreamingService(){}

pool::TestBlobStreamingService::~TestBlobStreamingService()
{}



pool::IBlobWriter*
pool::TestBlobStreamingService::newWriter( const Reflex::Type& classDictionary,
                                           const std::string& ) const
{
  if ( pool::ObjectRelationalClassUtils::isTypeNonAssociativeContainer(classDictionary) &&
       classDictionary.TemplateArgumentAt(0).IsFundamental() ) {
    return new pool::BlobWriter( classDictionary );
  }
  else
    return 0;
}


pool::IBlobReader*
pool::TestBlobStreamingService::newReader( const Reflex::Type& classDictionary,
                                           const std::string& ) const
{
  if ( pool::ObjectRelationalClassUtils::isTypeNonAssociativeContainer(classDictionary) &&
       classDictionary.TemplateArgumentAt(0).IsFundamental() ) {
    return new pool::BlobReader( classDictionary );
  }
  else
    return 0;
}
