#ifndef POOL_TESTBLOBSTREAMINGSERVICE_H
#define POOL_TESTBLOBSTREAMINGSERVICE_H

#include "POOLCore/IBlobStreamingService.h"
#if ROOT_VERSION_CODE < ROOT_VERSION(5,19,0)
using namespace ROOT;
#endif
namespace pool {

  /// Test implementation of the IBlobStreamingService interface
  
  class TestBlobStreamingService : virtual public IBlobStreamingService
  {
    
  public:
    /// Standard Constructor
    TestBlobStreamingService();
    
    /// Standard Destructor
    virtual ~TestBlobStreamingService();

  public:
    /// Returns a new NON-PORTABLE streamer for writing into a BLOB
    IBlobWriter* newWriter( const Reflex::Type& classDictionary,
                            const std::string& version ) const;

    /// Returns a new NON-PORTABLE streamer for reading from a BLOB
    IBlobReader* newReader( const Reflex::Type& classDictionary,
                            const std::string& version ) const;
  };

}

#endif
