#include "TestDriver.h"
#include <cstdlib>
#include <stdexcept>
#ifdef _WIN32
#include <windows.h>
#endif
int main( int,char**) {

  // Set the authentication and lookup paths
#ifdef _WIN32
	 const char* CoralEVar =  "CORAL_AUTH_PATH";
	 ::SetEnvironmentVariable(CoralEVar,"/afs/cern.ch/sw/lcg/app/pool/db");

	 const char* DBEVar =  "CORAL_DBLOOKUP_PATH";
	 ::SetEnvironmentVariable(DBEVar,"/afs/cern.ch/sw/lcg/app/pool/db");
#else
  if ( ! ::getenv( "CORAL_AUTH_PATH" ) ) {
    ::putenv( (char*)"CORAL_AUTH_PATH=/afs/cern.ch/sw/lcg/app/pool/db" );
  }

  if ( ! ::getenv( "CORAL_DBLOOKUP_PATH" ) ) {
    ::putenv( (char*)"CORAL_DBLOOKUP_PATH=/afs/cern.ch/sw/lcg/app/pool/db" );
  }
#endif

  const std::string connnectionString = "/pool/db/service_1";

  try{
    pool::TestDriver test(connnectionString);
    test.run();    
    std::cout << "[OVAL] Test completed."<<std::endl;
  } catch (const std::exception& e){
    std::cout << "[OVAL] ERROR: " << e.what() << std::endl;
    return 1;
  }
  return 0;
}
