#ifndef TESTCLASSES_H
#define TESTCLASSES_H

#include <string>
#include <vector>
#include <sstream>
#include <iostream>
#include <map>

class SimpleMember {

 public:
  SimpleMember():m_flag(false),m_id(0){}
  SimpleMember(const SimpleMember& mem):m_flag(mem.m_flag),m_id(mem.m_id){}
  SimpleMember& operator=(const SimpleMember& mem){
    m_flag = mem.m_flag;
    m_id = mem.m_id;
    return *this;
  }
  bool m_flag;
  long m_id;

};


class SimpleClass {

 public:

  SimpleClass():m_objectData(),m_map(),m_arrayData(),m_stringData(""),m_intData(0){}
  SimpleClass(unsigned int id):m_objectData(),m_map(),m_arrayData(),m_stringData(""),m_intData(id){
    m_intData = id;
    std::ostringstream os;
    os << "SimpleClass_"<<id; 
    m_stringData = os.str();
    m_objectData.m_flag = true;
    m_objectData.m_id = id;
    for(int i=0;i<(int)id;i++){
      m_arrayData.push_back(i);
    }
    for(unsigned long long i=0;i<(unsigned long long)id;i++){
      m_map.insert(std::make_pair(i,i));
    }
  }

  SimpleClass(const SimpleClass& obj){
    m_intData = obj.m_intData;
    m_stringData = obj.m_stringData;
    m_objectData = obj.m_objectData;
    m_arrayData = obj.m_arrayData;
    m_map = obj.m_map;
  }
  SimpleClass& operator=(const SimpleClass& obj){
    m_intData = obj.m_intData;
    m_stringData = obj.m_stringData;
    m_objectData = obj.m_objectData;
    m_arrayData = obj.m_arrayData;
    m_map = obj.m_map;
    return *this;
  }

  bool operator==(const SimpleClass& rhs){
    if(m_intData!=rhs.m_intData) return false;
    if(m_stringData!=rhs.m_stringData) return false;
    if(m_objectData.m_flag!=rhs.m_objectData.m_flag) return false;
    if(m_objectData.m_id!=rhs.m_objectData.m_id) return false;
    if(m_arrayData!=rhs.m_arrayData) return false;
    if(m_map!=rhs.m_map) return false;
    return true;
  }
  bool operator!=(const SimpleClass& rhs){
    return !operator==(rhs);
  }

  SimpleMember m_objectData;
  std::map<unsigned long long,unsigned long long> m_map;
  std::vector<int> m_arrayData;
  std::string m_stringData;
  unsigned int m_intData;
};

class DataClass {
 public:
  DataClass():m_f(0.),m_i(0){}
  DataClass(unsigned int id):m_f(0.+id),m_i(int(id)){}
  virtual ~DataClass(){}
  DataClass(const DataClass& cp):m_f(cp.m_f),m_i(cp.m_i){}
  DataClass& operator=(const DataClass& cp){
    m_f = cp.m_f;
    m_i = cp.m_i;
    return *this;
  }
  bool operator==(const DataClass& rhs){
    if(m_f!=rhs.m_f)return false;
    if(m_i!=rhs.m_i)return false;
    return true;
  }
  bool operator!=(const DataClass& rhs){
    return !operator==(rhs);
  }
  float m_f;
  int m_i;

};

namespace mynamespace {

class OtherClass {

 public:

  OtherClass():m_intData(0),m_stringData(""),m_objectData(),m_arrayData(){}
  OtherClass(unsigned int id):m_intData(id),m_stringData(""),m_objectData(),m_arrayData(){
    m_intData = id;
    std::ostringstream os;
    os << "OtherClass_"<<id; 
    m_stringData = os.str();
    m_objectData.m_flag = true;
    m_objectData.m_id = id;
    for(int i=0;i<(int)id;i++){
      m_arrayData.push_back(i);
    }
  }

  OtherClass(const OtherClass& obj):m_intData(obj.m_intData),m_stringData(obj.m_stringData),m_objectData(obj.m_objectData),m_arrayData(obj.m_arrayData){}
  OtherClass& operator=(const OtherClass& obj){
    m_intData = obj.m_intData;
    m_stringData = obj.m_stringData;
    m_objectData = obj.m_objectData;
    m_arrayData = obj.m_arrayData;
    return *this;
  }

  bool operator==(const OtherClass& rhs){
    if(m_intData!=rhs.m_intData) return false;
    if(m_stringData!=rhs.m_stringData) return false;
    if(m_objectData.m_flag!=rhs.m_objectData.m_flag) return false;
    if(m_objectData.m_id!=rhs.m_objectData.m_id) return false;
    if(m_arrayData!=rhs.m_arrayData) return false;
    return true;
  }
  bool operator!=(const OtherClass& rhs){
    return !operator==(rhs);
  }

  unsigned int m_intData;
  std::string m_stringData;
  SimpleMember m_objectData;
  std::vector<int> m_arrayData;
};
 
}

#endif
