#include "TestDriver.h"
#include <cstdlib>
#include <stdexcept>

int main( int,char**) {

  // Set the authentication and lookup paths
  if ( ! ::getenv( "CORAL_AUTH_PATH" ) ) {
    ::putenv( (char*)"CORAL_AUTH_PATH=/afs/cern.ch/sw/lcg/app/pool/db" );
  }

  if ( ! ::getenv( "CORAL_DBLOOKUP_PATH" ) ) {
    ::putenv( (char*)"CORAL_DBLOOKUP_PATH=/afs/cern.ch/sw/lcg/app/pool/db" );
  }
  const std::string connnectionString = "/pool/db/service_1";
  try{
    pool::TestDriver test(connnectionString);
    test.run();    
    std::cout << "[OVAL] Test completed."<<std::endl;
  } catch (const std::exception& e){
    std::cout << "[OVAL] ERROR: " << e.what() << std::endl;
    return 1;
  }
  return 0;
}
