#ifndef TESTCLASSES_H
#define TESTCLASSES_H

#include <string>
#include <vector>
#include <sstream>
#include <iostream>
#include "POOLCore/Ptr.h"

class SimpleMember {

 public:
  SimpleMember():m_flag(false),m_id(0){}
  SimpleMember(unsigned int i):m_flag(true),m_id(i){}
  SimpleMember(const SimpleMember& mem):m_flag(mem.m_flag),m_id(mem.m_id){}
  virtual ~SimpleMember(){
  }
  
  SimpleMember& operator=(const SimpleMember& mem){
    m_flag = mem.m_flag;
    m_id = mem.m_id;
    return *this;
  }
  bool operator==(const SimpleMember& rhs) const{
    if(m_flag!=rhs.m_flag) return false;
    if(m_id!=rhs.m_id) return false;
    return true;
  }
  bool operator!=(const SimpleMember& rhs) const {
    return !operator==(rhs);
  }
  
  bool m_flag;
  long m_id;

};

class BClass {
  public:
  BClass():mi(1){}
  virtual ~BClass(){}
  int mi;
};

class DClass: public BClass{
  public:
  DClass():BClass(),ml(2){}
  virtual ~DClass(){}
  long ml;
};

class SimplePtrClass 
{
  public:
  SimplePtrClass():ms(""),mid(0),arr(),mem(0){}
  SimplePtrClass(unsigned int i):ms(""),mid(i),arr(),mem(new SimpleMember(i)){
    for(unsigned int j=0;j<i;j++){
      arr.push_back(SimpleMember(i));
    }
    std::stringstream ss;
    ss << i;
    ms = ss.str();
  }
  bool operator==(const SimplePtrClass& rhs){
    if(ms!=rhs.ms) return false;
    if(mid!=rhs.mid) return false;
    if(arr!=rhs.arr) return false;    
    if(mem.get()){
      if(!rhs.mem) return false;
      if(*mem!=*rhs.mem) {
        std::cout << "Mem is different!"<< std::endl;
        return false;
      }
      
    } else{
      std::cout << "Mem has a null ptr"<< std::endl;
      if(rhs.mem.get()) return false;      
    }
    
    return true;
  }
  bool operator!=(const SimplePtrClass& rhs){
    return !operator==(rhs);
  }

  std::string ms;
  unsigned int mid;
  std::vector<SimpleMember> arr;
  pool::Ptr<SimpleMember> mem;
};

#endif
