#ifndef TESTCLASSES_H
#define TESTCLASSES_H

#include <string>
#include <vector>
#include <sstream>
#include <iostream>
#include <map>
#include <set>
#include "DataSvc/Ref.h"
#include "POOLCore/Ptr.h"

class SimpleMember {

 public:
  SimpleMember():m_flag(false),m_id(0),m_set(){}
  SimpleMember(long id):m_flag(false),m_id(0),m_set(){
    setValues(id);
  }
  SimpleMember(const SimpleMember& mem):m_flag(mem.m_flag),m_id(mem.m_id),m_set(mem.m_set){}
  SimpleMember& operator=(const SimpleMember& mem){
    m_flag = mem.m_flag;
    m_id = mem.m_id;
    m_set = mem.m_set;
    return *this;
  }

  void setValues(long id){
    m_id = id;
    if(m_id) m_flag = true;
    m_set.clear();
    for(long i=0;i<id;i++) {
      //m_set.insert((int)i);
      m_set.push_back((int)i);
    }
  }
  
  bool operator==(const SimpleMember& rhs) const {
    if(m_flag!=rhs.m_flag)return false;
    if(m_id!=rhs.m_id)return false;
    if(m_set!=rhs.m_set)return false;
    return true;
  }
  bool operator!=(const SimpleMember& rhs) const {
    return !operator==(rhs);
  }
  bool m_flag;
  long m_id;
  //std::set<int> m_set;
  std::vector<int> m_set;
};

class DataClass {
 public:
  DataClass():m_f(0.),m_i(0){}
  DataClass(unsigned int id):m_f(0.+id),m_i(int(id)){}
  virtual ~DataClass(){}
  bool operator==(const DataClass& rhs){
    if(m_f!=rhs.m_f)return false;
    if(m_i!=rhs.m_i)return false;
    return true;
  }
  bool operator!=(const DataClass& rhs){
    return !operator==(rhs);
  }
  float m_f;
  int m_i;

};

class BulkData 
{
 public:
  BulkData():m_i(0),m_s(""),m_arr(){
    for(int i=0;i<3;i++) m_carr0[i]=0;    
    for(int i=0;i<110;i++) m_carr1[i]=0;
  }
  BulkData(unsigned int id):m_i(id),m_s(""),m_arr(){
    for(int i=0;i<3;i++) m_carr0[i]=0;    
    for(int i=0;i<110;i++) m_carr1[i]=0;
    setValues(id);
  }

  void setValues(unsigned int id){
    std::ostringstream os;
    os << "BulkData_"<<id; 
    m_s = os.str();
    m_arr.clear();
    for(unsigned int i=0;i<3;i++){
      std::vector<SimpleMember> vec;
      for(unsigned int j=0;j<id;j++){
        vec.push_back(SimpleMember((long)j));
      }
      m_arr.push_back(vec);
    }
    for(int i=0;i<3;i++) m_carr0[i]=i+id;    
    for(int i=0;i<110;i++) m_carr1[i]=i+id;
  }
  
  virtual ~BulkData(){}
  bool operator==(const BulkData& rhs){
    if(m_i!=rhs.m_i){
      std::cout << "## code 10-0"<<std::endl;
      return false;
    }
    
    if(m_s!=rhs.m_s){
      std::cout << "## code 10-1"<<std::endl;
      return false;
    }
    for(unsigned int i=0;i<3;i++){
      if(m_arr[i]!=rhs.m_arr[i]){
      std::cout << "## code 10-3"<<std::endl;
        return false;
      }
    }
    for(int i=0;i<3;i++) if(m_carr0[i]!=rhs.m_carr0[i]) {
      std::cout << "## code 10-4"<<std::endl;
      return false;
    }
    
    for(int i=0;i<110;i++) if(m_carr1[i]!=rhs.m_carr1[i]) {
      std::cout << "## code 10-5"<<std::endl;
      return false;
    }
    
    return true;
  }
  bool operator!=(const BulkData& rhs){
    return !operator==(rhs);
  }
  
  unsigned int m_i;
  std::string m_s;
  std::vector<std::vector<SimpleMember> > m_arr;
  int m_carr0[3];
  int m_carr1[110];
};


class SimpleClass {

 public:

  SimpleClass():m_intData(0),m_fixedData(999),m_stringData(""),m_objectData(),m_arrayData(),m_map(),m_code(ZERO),m_data(),m_ptr(){}
  SimpleClass(unsigned int id):m_intData(0),m_fixedData(999),m_stringData(""),m_objectData(),m_arrayData(),m_map(),m_code(ZERO),m_data(),m_ptr(){
    setValues(id);
  }

  virtual ~SimpleClass(){
    if(m_ptr.get()) delete m_ptr.get();
  }

  bool setValues(unsigned int id){
    m_intData = id;
    std::ostringstream os;
    os << "SimpleClass_"<<id; 
    m_stringData = os.str();
    m_objectData.m_flag = true;
    m_objectData.m_id = id;
    m_arrayData.clear();
    for(int i=0;i<(int)id;i++){
      m_arrayData.push_back(i);
    }
    m_map.clear();
    for(unsigned long long i=0;i<(unsigned long long)id;i++){
       m_map.insert(std::make_pair(i,i));
    }
    m_code = ONE;
    if(id % 2 !=0 ){
      m_code = TWO;
    }
    if(m_ptr.get()) delete m_ptr.get();
    m_ptr = new BulkData(id);
    return true;
  }
  
  bool operator==(const SimpleClass& rhs){
    if(m_intData!=rhs.m_intData){
      std::cout << "## code 0"<<std::endl;
      return false;
    }
    if(m_fixedData!=rhs.m_fixedData) {
      std::cout << "## code 1"<<std::endl;
      return false;
    }
    if(m_stringData!=rhs.m_stringData) {
      std::cout << "## code 2"<<std::endl;
      return false;
    }
    
    if(m_objectData.m_flag!=rhs.m_objectData.m_flag) {
      std::cout << "## code 3"<<std::endl;
      return false;
    }
    
    if(m_objectData.m_id!=rhs.m_objectData.m_id) {
      std::cout << "## code 4"<<std::endl;
      return false;
    }
    
    if(m_objectData.m_set!=rhs.m_objectData.m_set) {
      std::cout << "## code 5"<<std::endl;
      return false;
    }
    
    if(m_arrayData!=rhs.m_arrayData) {
      std::cout << "## code 6"<<std::endl;
      return false;
    }
    
    if(m_map!=rhs.m_map) {
      std::cout << "## code 7"<<std::endl;
      return false;
    }
    
    if(m_code!=rhs.m_code) {
      std::cout << "## code 8"<<std::endl;
      return false;
    }
    
    if(m_data){
      if(!rhs.m_data) return false;
      if(m_data->operator!=(*rhs.m_data)) {
      std::cout << "## code 9"<<std::endl;
        return false;
      }
      
    }

    if(m_ptr){
      if(!rhs.m_ptr) return false;
      if(m_ptr->operator!=(*rhs.m_ptr)) {
      std::cout << "## code 10"<<std::endl;
        return false;
      }
    }
    
    return true;
  }
  bool operator!=(const SimpleClass& rhs){
    return !operator==(rhs);
  }

  enum MySimpleClassCode { ZERO, ONE, TWO };
  typedef MySimpleClassCode Code;
  unsigned int m_intData;
  int m_fixedData;
  std::string m_stringData;
  SimpleMember m_objectData;
  std::vector<int> m_arrayData;
  std::map<unsigned long long,unsigned long long> m_map;
  Code m_code;
  pool::Ref<DataClass> m_data;
  pool::Ptr<BulkData> m_ptr;
};

std::set<int> a;

#endif
