#include "TestBase.h"

#include "FileCatalog/IFCDomain.h"

#include "PluginManager/PluginManager.h"
#include "SealKernel/Context.h"
#include "SealKernel/ComponentLoader.h"

#include <cstdlib>

TestBase::TestBase():
  m_context( new seal::Context )
{
  seal::PluginManager* pm = seal::PluginManager::get();
  pm->initialise();
  seal::Handle<seal::ComponentLoader> loader = new seal::ComponentLoader( m_context );
  loader->load( "SEAL/Services/MessageService" );
  loader->load( "CORAL/Services/ConnectionService" );
  loader->load( "POOL/CatalogPlugins/xmlcatalog" );
}

TestBase::~TestBase()
{
  delete m_context;
}

void TestBase::resetCatalog( const std::string& connectionString )
{
}

pool::IFileCatalogImpl* TestBase::retrieveCatalog( const std::string& connectionString )
{
  return m_context->query<pool::IFCDomain>( "POOL/CatalogPlugins/xmlcatalog" )->newFileCatalogImpl( connectionString );
}
